%global githash 70a77f4
%global gitdate 20230616

Name:           nnpack
Version:        0
Release:        %{gitdate}.git%{githash}%{?dist}
Summary:        Acceleration package for neural networks on multi-core CPUs
License:        BSD
URL:            https://github.com/Maratyszcza/nnpack

Source0:        %{name}.tar.xz

BuildRequires:  cmake gcc-c++
BuildRequires:  python3-devel python3-six
BuildRequires:  peachpy-python3 opcodes-python3 fp16-python3
BuildRequires:  cpuinfo-devel fxdiv-devel pthreadpool-devel psimd-devel fp16-devel

%global __cmake_in_source_build 1

%description
Acceleration package for neural networks on multi-core CPUs

%package        devel
Summary:        Development files
Requires:       %{name} = %{version}-%{release}

%description    devel
This package contains the development files.


%prep
%setup -q -n %{name}


%build
# externals
sed -i '/PRIVATE fp16/d' CMakeLists.txt
sed -i '/PRIVATE psimd/d' CMakeLists.txt
sed -i '/PRIVATE fxdiv/d' CMakeLists.txt
sed -i '/NOT TARGET/,/ENDIF/d' CMakeLists.txt
sed -i -e 's/PROCESSOR MATCHES "^(i686/PROCESSOR MATCHES "^(ppc64le|i686/g' CMakeLists.txt
sed -i -e 's|COMMAND "PYTHONPATH=${PEACHPY_PYTHONPATH}"|COMMAND "NOPYTHONPATH=${PEACHPY_PYTHONPATH}"|g' CMakeLists.txt
sed -i -e 's|PROPERTIES PUBLIC_HEADER include/nnpack.h|PROPERTIES PUBLIC_HEADER include/nnpack.h SOVERSION 1 VERSION 1.0|g' CMakeLists.txt

mkdir build
pushd build
%cmake .. \
       -DCMAKE_SKIP_RPATH=ON \
       -DCMAKE_VERBOSE_MAKEFILE=OFF \
       -DCMAKE_BUILD_TYPE=RelWithDebInfo \
       -DNNPACK_BUILD_TESTS=OFF \
       -DNNPACK_BUILD_BENCHMARKS=OFF \
       -DPYTHON_SIX_SOURCE_DIR="%{python3_sitearch}" \
       -DPYTHON_ENUM_SOURCE_DIR="%{python3_sitearch}" \
       -DPYTHON_PEACHPY_SOURCE_DIR="%{python3_sitelib}/peachpy" \
       -DFP16_SOURCE_DIR="%{_includedir}" \
       -DPSIMD_SOURCE_DIR="%{_includedir}" \
       -DFXDIV_SOURCE_DIR="%{_includedir}" \
       -DCPUINFO_SOURCE_DIR="%{_includedir}" \
       -DPTHREADPOOL_SOURCE_DIR="%{_includedir}"
make %{?_smp_mflags}
popd


%install
rm -rf %{buildroot}

pushd build
make install DESTDIR=%{buildroot}
popd

mkdir -p %{buildroot}%{_libdir}
mv -f %{buildroot}/usr/lib/* %{buildroot}%{_libdir}/ || true


rm -rf %{buildroot}/%{_includedir}/gmock
rm -rf %{buildroot}/%{_includedir}/gtest
rm -rf %{buildroot}/%{_libdir}/*.a


%files
%license LICENSE
%doc README.md
%{_libdir}/lib*.so.*

%files devel
%license LICENSE
%doc README.md
%{_includedir}/*
%{_libdir}/lib*.so


%changelog
* Fri Jun 16 2023 forrest_ly <flin@linux.alibaba.com> - 0-20230616.git70a77f4
- init for anolis 23
